// BonTsDemuxDlg.cpp : t@C
//

#include "stdafx.h"
#include "BonTsDemux.h"
#include "BonTsDemuxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBonTsDemuxDlg _CAO




CBonTsDemuxDlg::CBonTsDemuxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBonTsDemuxDlg::IDD, pParent)
	, m_TsConverter(this)
	, m_csTsPath(_T(""))
	, m_csVideoPath(_T(""))
	, m_csAudioPath(_T(""))
	, m_bAacDecode(FALSE)
	, m_bLipSync(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBonTsDemuxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_TSPATH, m_csTsPath);
	DDX_Text(pDX, IDC_VIDEOPATH, m_csVideoPath);
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_COMBO1, m_ComboEncode);
}

BEGIN_MESSAGE_MAP(CBonTsDemuxDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BROWSETS, &CBonTsDemuxDlg::OnBnClickedBrowseTs)
	ON_BN_CLICKED(IDC_BROWSEVIDEO, &CBonTsDemuxDlg::OnBnClickedBrowseVideo)
	ON_BN_CLICKED(IDC_START, &CBonTsDemuxDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CBonTsDemuxDlg::OnBnClickedStop)
END_MESSAGE_MAP()


// CBonTsDemuxDlg bZ[W nh

BOOL CBonTsDemuxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	wchar_t szModulePath[256],drv[10],path[256],ext[256],appname[256],execname[256];
	wchar_t enc_param[256];
	enc_param[0] = NULL;
	GetModuleFileName(NULL,szModulePath,256);
	_wsplitpath(szModulePath,drv,path,appname,ext);
	_wmakepath(execname,drv,path,L"cap_sts_sea",L"ini");
	m_ini_path = execname;

	FILE	*fp;
	CString pg;
	wchar_t buffer[WCHAR_MAX];
	errno_t err;

	m_ComboEncode.Clear();

	m_ComboEncode.AddString(L"demux only");

	err = _wfopen_s(&fp, execname , L"rt");	//ǂݍݐpAeLXg[h

	for(;;){
		if(fgetws(buffer, WCHAR_MAX, fp) == NULL){	//sǂݍ(S-JIS -> Unicodeϊ)
			// gȂ
			fclose(fp);
			break;
		}
		if(wcsstr(buffer, L"[VLC_SETTING]") == buffer){
			pg = L"";
			continue;
		} else if(wcsstr(buffer, L"[FFMPEG_SETTING]") == buffer){
			pg = L"ffmpeg:";
			continue;
		} else if(wcsstr(buffer, L"[") == buffer){
			pg = "";
		} else if(wcsstr(buffer, L";")){
			continue;
		} else if(wcsstr(buffer, L"PATH")){
			continue;
		}

		if(pg != ""){
			wchar_t* arg;
			arg = wcsstr(buffer, L"=");
			if(arg == NULL) continue;
			*arg=NULL;
			CString buf;
			buf=buffer;
			buf.Trim();
			m_ComboEncode.AddString(buf);
		}
	}

	m_ComboEncode.SetCurSel(0);



	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBonTsDemuxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBonTsDemuxDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBonTsDemuxDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CBonTsDemuxDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
}

void CBonTsDemuxDlg::OnBnClickedBrowseTs()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(TRUE, TEXT("ts"), NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TEXT("TSt@C (*.ts)|*.ts||"));

	if(Dlg.DoModal() == IDOK){
		m_csTsPath = Dlg.GetPathName();
		
		m_csVideoPath = m_csTsPath;
		m_csVideoPath.Replace(TEXT(".ts"), TEXT(".avi"));
		
		m_csAudioPath = m_csTsPath;
		m_csAudioPath.Replace(TEXT(".ts"), TEXT(".aac"));
				
		UpdateData(FALSE);
		}
}

void CBonTsDemuxDlg::OnBnClickedBrowseVideo()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(FALSE, TEXT("*"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("t@C (*.*)|*.*||"));
	if(Dlg.DoModal() != IDOK)return;

	m_csVideoPath = Dlg.GetPathName();

	UpdateData(FALSE);
}

void CBonTsDemuxDlg::OnBnClickedBrowseAudio()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(FALSE, TEXT("aac"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("aact@C (*.aac)|*.aac|wavt@C (*.wav)|*.wav||"));
	if(Dlg.DoModal() != IDOK)return;
	
	m_csAudioPath = Dlg.GetPathName();
	m_bAacDecode = (Dlg.GetFileExt() == TEXT("aac"))? false : true;
		
	UpdateData(FALSE);
}

void CBonTsDemuxDlg::OnBnClickedVideoOut()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);
	
	GetDlgItem(IDC_VIDEOPATH)->EnableWindow(m_bVideoOut);
	GetDlgItem(IDC_BROWSEVIDEO)->EnableWindow(m_bVideoOut);
}

void CBonTsDemuxDlg::OnBnClickedAudioOut()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);
	
}

void CBonTsDemuxDlg::OnBnClickedAacDecode()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);
	
	if(m_bAacDecode){
		m_csAudioPath.Replace(TEXT(".aac"), TEXT(".wav"));
		}
	else{
		m_csAudioPath.Replace(TEXT(".wav"), TEXT(".aac"));
		}
		
	UpdateData(FALSE);
}

void CBonTsDemuxDlg::OnBnClickedStart()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	OnBnClickedAacDecode();
	
//	if(!m_bVideoOut && !m_bAudioOut){
//		::AfxMessageBox(TEXT("rfI܂̓I[fBIo͐ݒɂĂB"));
//		return;
//		}

	wchar_t buff[1024],param[256];
	m_ComboEncode.GetLBText( m_ComboEncode.GetCurSel(),param );
	GetPrivateProfileString(L"FFMPEG_SETTING",param,L"",buff,sizeof(buff),m_ini_path);
	
	if(buff[0] == NULL){
		m_csVideoPath.Replace(TEXT(".avi"), TEXT(""));

		m_csAudioPath = m_csVideoPath + L".wav";
		m_csVideoPath += L".m2v";
	}

	
	// Ro[gJn
	const bool bReturn = m_TsConverter.ConvertTsFile(m_csTsPath,
													(LPCTSTR)m_csVideoPath,
													(LPCTSTR)m_csAudioPath,
													true,//(m_bAacDecode)? true : false,
													true,//(m_bLipSync)? true : false,
													buff
													);
	
	if(!bReturn){
		::AfxMessageBox(TEXT("t@C̃I[vɎs܂B"));
		}
}

void CBonTsDemuxDlg::OnBnClickedStop()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_TsConverter.CancelConvert();
}

void CBonTsDemuxDlg::LockControl(const BOOL bLock)
{
	// Rg[bN
	const BOOL bEnable = (bLock)? FALSE : TRUE;

	GetDlgItem(IDC_START)->EnableWindow(bEnable);
	GetDlgItem(IDC_BROWSETS)->EnableWindow(bEnable);
	GetDlgItem(IDC_BROWSEVIDEO)->EnableWindow(bEnable);
	GetDlgItem(IDC_TSPATH)->EnableWindow(bEnable);
	GetDlgItem(IDC_VIDEOPATH)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO1)->EnableWindow(bEnable);
}

void  CBonTsDemuxDlg::OnTsConverterStart(const ULONGLONG llFileSize)
{
	// ϊJnCxg
	LockControl(TRUE);
	m_Progress.SetRange(0, 1000);

	m_Progress.SetPos(0);
}

void  CBonTsDemuxDlg::OnTsConverterEnd(const ULONGLONG llFileSize)
{
	// ϊICxg
	SetDlgItemText(IDC_INFOVIEW, TEXT("ϊ܂"));

	LockControl(FALSE);
}

void CBonTsDemuxDlg::OnTsConverterProgress(const ULONGLONG llCurPos, const ULONGLONG llFileSize)
{
	// iXVCxg
	m_Progress.SetPos((int)((llCurPos * 1000ULL) / llFileSize));
}

void CBonTsDemuxDlg::OnTsConverterServiceName(LPCTSTR lpszServiceName)
{
	// T[rXXVCxg
	CString csText;
	csText.Format(TEXT("T[rXF %s"), lpszServiceName);
	SetDlgItemText(IDC_INFOVIEW, csText);
}
