// BonTsDemuxDlg.h : wb_[ t@C
//

#pragma once
#include "afxcmn.h"
#include "TsConverter.h"
#include "afxwin.h"


// CBonTsDemuxDlg _CAO
class CBonTsDemuxDlg : public CDialog, protected CTsConverter::IEventHandler
{
// RXgNV
public:
	CBonTsDemuxDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_BONTSDEMUX_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g

// 
protected:

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
	
	afx_msg void OnBnClickedAacDecode();
	afx_msg void OnBnClickedBrowseTs();
	afx_msg void OnBnClickedBrowseVideo();
	afx_msg void OnBnClickedBrowseAudio();
	afx_msg void OnBnClickedVideoOut();
	afx_msg void OnBnClickedAudioOut();
	afx_msg void OnBnClickedStart();
	afx_msg void OnBnClickedStop();
	afx_msg void OnDestroy();

	void LockControl(const BOOL bLock = TRUE);

// CTsConverter::IEventHandler
	virtual void OnTsConverterStart(const ULONGLONG llFileSize);
	virtual void OnTsConverterEnd(const ULONGLONG llFileSize);
	virtual void OnTsConverterProgress(const ULONGLONG llCurPos, const ULONGLONG llFileSize);
	virtual void OnTsConverterServiceName(LPCTSTR lpszServiceName);

	HICON m_hIcon;
	CString m_csTsPath;
	CString m_csVideoPath;
	CString m_csAudioPath;
	BOOL m_bVideoOut;
	BOOL m_bAudioOut;
	BOOL m_bAacDecode;
	BOOL m_bLipSync;
	CProgressCtrl m_Progress;
	
	CTsConverter m_TsConverter;
	CComboBox m_ComboEncode;
	CString m_ini_path;
};
